org.eclipse.actf.visualization.eval.problem

## Interface IProblemItem

All Known Subinterfaces:
  IBlindProblem, IProblemItemImage

All Known Implementing Classes:
  ProblemItemImpl

    public interface IProblemItem

Interface for problem information

### Field Summary

Fields
`static int` `SEV_ERROR` Severity: error
`static int` `SEV_INFO` Severity: informational
`static int` `SEV_USER` Severity: user check
`static int` `SEV_WARNING` Severity: warning

### Method Summary

Methods
`void` `accept(IProblemItemVisitor visitor)` Accept `IProblemItemVisitor`.
`String` `getDescription()`
`IEvaluationItem` `getEvaluationItem()`
`HighlightTargetId[]` `getHighlightTargetIds()`
`HighlightTargetNodeInfo` `getHighlightTargetNodeInfo()`
`HighlightTargetSourceInfo[]` `getHighlightTargetSoruceInfo()`
`String` `getId()`
`int` `getLine()`
`String` `getLineStr()`
`String` `getLineStrMulti()`
`Image[]` `getMetricsIcons()`
`int[]` `getMetricsScores()`
`int` `getSerialNumber()`
`int` `getSeverity()`
`String` `getSeverityStr()`
`int` `getSubType()`
`String[]` `getTableDataGuideline()`
`Node` `getTargetNode()`
`String` `getTargetString()`
`String` `getTargetStringForExport()`
`boolean` `isCanHighlight()`
`void` `setCanHighlight(boolean canHighlight)` Set if his error position can highlight in visualization result view
`void` `setDescription(String description)` Set description about this problem
`void` `setEvaluationItem(IEvaluationItem evalItem)` Set `IEvaluationItem` relates to this problem
`void` `setHighlightTargetIds(HighlightTargetId targetId)` Set `HighlightTargetId` corresponds to this problem
`void` `setHighlightTargetIds(HighlightTargetId[] targetIds)` Set array of `HighlightTargetId` corresponds to this problem
`void` `setHighlightTargetNodeInfo(HighlightTargetNodeInfo targetNodeInfo)` Set `HighlightTargetNodeInfo`.
`void` `setHighlightTargetSourceInfo(HighlightTargetSourceInfo targetSourceInfo)` Set `HighlightTargetSourceInfo` corresponds to this problem
`void` `setHighlightTargetSourceInfo(HighlightTargetSourceInfo[] targetSourceInfo)` Set array of `HighlightTargetSourceInfo` corresponds to this problem
`void` `setLine(int line)` Set line number of the problem position
`void` `setSerialNumber(int serialNumber)` Set serial number for this problem
`void` `setSubType(int subType)` Set problem sub type
`void` `setTargetNode(Node targetNode)` Set target `Node` of this problem
`void` `setTargetString(String targetString)` Set target String will be embedded into description
`void` `setTargetStringForExport(String targetString)` Set target String will be used to export this problem item

### Field Detail

#### SEV_ERROR

    static final int SEV_ERROR

Severity: error

See Also:
  Constant Field Values

#### SEV_WARNING

    static final int SEV_WARNING

Severity: warning

See Also:
  Constant Field Values

#### SEV_USER

    static final int SEV_USER

Severity: user check

See Also:
  Constant Field Values

#### SEV_INFO

    static final int SEV_INFO

Severity: informational

See Also:
  Constant Field Values

### Method Detail

#### getEvaluationItem

    IEvaluationItem getEvaluationItem()

Returns:
  related evaluation item information

#### getDescription

    String getDescription()

Returns:
  description about the problem

#### getSerialNumber

    int getSerialNumber()

Returns:
  serial number

#### getTargetNode

    Node getTargetNode()

Returns:
  target `Node` of the problem

#### getTargetString

    String getTargetString()

Returns:
  target String will be embedded into description

#### getTargetStringForExport

    String getTargetStringForExport()

Returns:
  target String will be used to export this problem item

#### isCanHighlight

    boolean isCanHighlight()

Returns:
  true if this error position can highlight in visualization result view

#### setCanHighlight

    void setCanHighlight(boolean canHighlight)

Set if his error position can highlight in visualization result view

Parameters:
  `canHighlight` - true if this error position can highlight in visualization result view

#### setEvaluationItem

    void setEvaluationItem(IEvaluationItem evalItem)

Set `IEvaluationItem` relates to this problem

Parameters:
  `evalItem` -

#### setDescription

    void setDescription(String description)

Set description about this problem

Parameters:
  `description` -

#### setSerialNumber

    void setSerialNumber(int serialNumber)

Set serial number for this problem

Parameters:
  `serialNumber` - serial number

#### setHighlightTargetNodeInfo

    void setHighlightTargetNodeInfo(HighlightTargetNodeInfo targetNodeInfo)

Set `HighlightTargetNodeInfo`.

Parameters:
  `targetNodeInfo` - target `HighlightTargetNodeInfo`

#### getHighlightTargetNodeInfo

    HighlightTargetNodeInfo getHighlightTargetNodeInfo()

Returns:
  corresponding `HighlightTargetNodeInfo` of this problem

#### setHighlightTargetIds

    void setHighlightTargetIds(HighlightTargetId targetId)

Set `HighlightTargetId` corresponds to this problem

Parameters:
  `targetId` - target `HighlightTargetId`

#### setHighlightTargetIds

    void setHighlightTargetIds(HighlightTargetId[] targetIds)

Set array of `HighlightTargetId` corresponds to this problem

Parameters:
  `targetIds` - array of target `HighlightTargetId`

#### getHighlightTargetIds

    HighlightTargetId[] getHighlightTargetIds()

Returns:
  array of `HighlightTargetId` corresponds to this problem

#### setTargetNode

    void setTargetNode(Node targetNode)

Set target `Node` of this problem

Parameters:
  `targetNode` - target Node

#### setTargetString

    void setTargetString(String targetString)

Set target String will be embedded into description

Parameters:
  `targetString` - target String

#### setTargetStringForExport

    void setTargetStringForExport(String targetString)

Set target String will be used to export this problem item

Parameters:
  `targetString` - target String

#### getLine

    int getLine()

Returns:
  line number of the problem position

#### getLineStr

    String getLineStr()

Returns:
  line number of the problem position as String

#### setLine

    void setLine(int line)

Set line number of the problem position

Parameters:
  `line` - line number

#### getLineStrMulti

    String getLineStrMulti()

Returns:
  related line numbers of the problem as comma separated String

#### setHighlightTargetSourceInfo

    void setHighlightTargetSourceInfo(HighlightTargetSourceInfo targetSourceInfo)

Set `HighlightTargetSourceInfo` corresponds to this problem

Parameters:
  `targetSourceInfo` - target `HighlightTargetSourceInfo`

#### setHighlightTargetSourceInfo

    void setHighlightTargetSourceInfo(HighlightTargetSourceInfo[] targetSourceInfo)

Set array of `HighlightTargetSourceInfo` corresponds to this problem

Parameters:
  `targetSourceInfo` - array of target `HighlightTargetSourceInfo`

#### getHighlightTargetSoruceInfo

    HighlightTargetSourceInfo[] getHighlightTargetSoruceInfo()

Returns:
  corresponding `HighlightTargetSourceInfo` of this problem

#### accept

    void accept(IProblemItemVisitor visitor)

Accept `IProblemItemVisitor`. This method can be used to export problem list, filter some problem items, etc.

Parameters:
  `visitor` - target `IProblemItemVisitor` to accept

#### getId

    String getId()

Returns:
  evaluation item ID

#### getSeverity

    int getSeverity()

Returns:
  get severity of this problem

#### getSeverityStr

    String getSeverityStr()

Returns:
  get severity as String

#### getMetricsScores

    int[] getMetricsScores()

Returns:
  get evaluation metrics scores relate to this problem

#### getMetricsIcons

    Image[] getMetricsIcons()

Returns:
  get icons for evaluation metrics

#### getTableDataGuideline

    String[] getTableDataGuideline()

Returns:
  get related guideline information as String array

#### getSubType

    int getSubType()

Returns:
  sub type of the problem

#### setSubType

    void setSubType(int subType)

Set problem sub type

Parameters:
  `subType` - problem sub type